# -*- coding: utf-8 -*-
from setuphelpers import *

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls

bin_contains = "OpenJDK17"
bin_type = "jre"
msi_properties = "INSTALLLEVEL=1 ADDLOCAL=FeatureJavaHome,FeatureOracleJavaSoft"


def install():
    # Declaring local variables
    package_version = control.get_software_version()

    # removing older versions
    for to_uninstall in installed_softwares(name=r"Eclipse Temurin JRE"):
        if Version(to_uninstall["version"]) < Version(package_version) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(control.impacted_process.split(","))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])

    # Installing the software
    if "x64" in ensure_list(control.architecture) or "all" in ensure_list(control.architecture) and iswin64():
        bin_name_x64 = glob.glob("*%s*x64*.msi" % bin_contains)[0]
        install_msi_if_needed(
            bin_name_x64,
            properties=msi_properties,
        )

    if "x86" in ensure_list(control.architecture) or "all" in ensure_list(control.architecture):
        bin_name_x86 = glob.glob("*%s*x86*.msi" % bin_contains)[0]
        install_msi_if_needed(
            bin_name_x86,
            properties=msi_properties,
        )
